function CDS_to_RAW1_pathname, cds_name
;
;   uses a CDS pathname to build a corresponding RAW1 pathname
;
;   assumes:
;
;      1. RAW1 directory is ../RAW1_RAW relative to CDS_RAW
;             directory
;      2. Windows type file name slashes (backslashes)
;
;   DPC     20050801  original code
;           20051026 modified to test OS type
;
;
;print, "CDS file = ",cds_name
raw_name = STRSPLIT(cds_name,"CDS_RAW",COUNT=count,/EXTRACT,/REGEX)
if(count ne 2) then begin
    print, "Error on RAW1 pathname parsing"
    print, "  found count = ",count," when using STRSPLIT(*,CDS_RAW)"
    print, "  Stopping"
    stop
endif
;
;   now, split second half, looking for '.' separators
;
raw_name_second = STRSPLIT(raw_name[1],'.',COUNT=count,/EXTRACT)
if(count ne 3) then begin
    print, "Error on RAW1 name parsing"
    print, " Got Count = ",count," where 3 was expected"
    print, " string to be parsed = ",raw_name[1]
    print, "Stopping"
    stop
endif
;
;   extract the raw frame number
;
reads, raw_name_second[1], format="(i)",raw_number
;
;   build raw name
;
raw_pathname = raw_name[0] + 'RAW1_RAW' + PATH_SEP() + 'raw1_' + raw_name_second[1]
;print, "RAW file pathname = ",raw_pathname
;
return, raw_pathname
end