;
; IDL Event Callback Procedures
; Dialog_Text_Window_eventcb
;
; Generated on:	10/22/2007 14:19.08
;

;-----------------------------------------------------------------
pro Dialog_Text_PostCreation, wWidget, _EXTRA=DTW_struct_ptr
    ;
    DTW_ptr =DTW_struct_ptr.ptr
    ;
    (*DTW_ptr).widget_wid = wWidget
    ;
    ;	change font, if selected
    ;
    if((*DTW_ptr).font ne '') then WIDGET_CONTROL, DEFAULT_FONT=(*DTW_ptr).font
    ;
    ;	attach pointer to wWidget
    ;
    WIDGET_CONTROL, wWidget, SET_UVALUE=DTW_ptr	; save the pointer only
    ;
    ;print, "in DTW post creation, updated all ids: label, text, title, base widget = ",$
    ;         label_wid, text_wid, title_wid, wWidget
    ;
end

;-----------------------------------------------------------------
pro Dialog_Text_Window_Realize, wWidget
	;
    WIDGET_CONTROL, wWidget, GET_UVALUE=DTW_ptr
    ;
    ;	now, all the widgets are realized, so update the missing ones
    ;
    label_wid = WIDGET_INFO( wWidget, FIND_BY_UNAME="Dialog_Text_Label_Window")
    text_wid = WIDGET_INFO( wWidget, FIND_BY_UNAME="Dialog_Text_Text_Window")
    title_wid = WIDGET_INFO( wWidget, FIND_BY_UNAME="Dialog_Text_Window_Base")
    ;
    (*DTW_ptr).label_wid = label_wid
    (*DTW_ptr).text_wid = text_wid
    (*DTW_ptr).title_wid = title_wid
    ;
    ;   try to move the pop up window to right hand side of display
	;
	WIDGET_CONTROL, wWidget, XOFFSET=500     ; pixels
	;
	;	change the title and label fields
	;
	if((*DTW_ptr).do_title ne 0) then WIDGET_CONTROL, title_wid, BASE_SET_TITLE=(*DTW_ptr).title
	;
	if((*DTW_ptr).do_label ne 0) then WIDGET_CONTROL, label_wid, SET_VALUE=(*DTW_ptr).label
    ;
    ;print, "in DTW realize, updated all ids: label, text, title, base widget = ",$
    ;         label_wid, text_wid, title_wid, wWidget
    ;print, "in DTW realize, text_string = ",(*DTW_ptr).text_string
end

;-----------------------------------------------------------------
pro Dialog_Text_String_Inserted, Event
	;
	;	fetch the text string and put it into the structure
	;
	PU_ID = WIDGET_INFO (Event.top, FIND_BY_UNAME="Dialog_Text_Text_Window")
    ;
    ;print," in Dialog_Text_String_Inserted, Event structure = ",Event
    ;help, Event, /struct
    ;
    if(Event.ch eq 10B) then begin
    	;print, "Found CR"
    	;
    	;	CR found, call "Done"
    	;
    	PU_ID = WIDGET_INFO (Event.top, FIND_BY_UNAME="Dialog_Text_Done_Button")
    	;
    	;	create a button Event
    	;
    	B_Event = {WIDGET_BUTTON, ID: 0L, TOP: 0L, HANDLER: 0L, SELECT: 0}
    	B_Event.ID = LONG(PU_ID)
    	B_Event.TOP = LONG(Event.top)
    	B_Event.HANDLER = LONG(Event.handler)
    	B_Event.SELECT = 1
    	;
    	;print, "B_Event: ",B_event
    	;
    	Dialog_Text_Done_Asserted, B_Event
    	goto, DTW_end
    endif
    ;
    ;help, Event, /struc
    ;
    ;	get the structure, update, save
    ;
    w_id = Event.top
    WIDGET_CONTROL, w_id, GET_UVALUE=DTW_ptr
    ;
    ;print, "in string insert:"
    ;help, DTW_ptr
    ;help, *DTW_ptr, /struct
    ;
    ;	trap only character generation (type=0) events
    ;
    if(Event.type eq 0) then begin
	    WIDGET_CONTROL, PU_ID, GET_VALUE=text_string
	    ;
	    ;print, "text_string = ",text_string
	    ;
	    case N_ELEMENTS(text_string) of
	    		0:  (*DTW_ptr).text_string = 'null'
	    		1:  (*DTW_ptr).text_string = text_string
	    		else: begin
	    				nch = N_ELEMENTS(text_string)
	    				new_string = ''
	    				for ich = 0, nch-1 do begin
	    					new_string = new_string + text_string[ich]
	    				endfor
	    				(*DTW_ptr).text_string = new_string
	    			   end
	    endcase
	    ;
	endif
	DTW_end:
end

;-----------------------------------------------------------------
pro Dialog_Text_Done_Asserted, Event
    ;
    ;  find the root of the pop up
    ;
    ;print," in Dialog_Text_Done, Event structure = ",Event
    ;help, Event, /struc
    ;
    ;	fetch the pointer, update the structure, then kill the
    ;	gui system
    ;
    w_id = Event.top
    WIDGET_CONTROL, w_id, GET_UVALUE=DTW_ptr
    ;
    ;help, DTW_ptr
    ;help, *DTW_ptr,/structure
    ;
    ;	set all wids to zero to signify closure
    ;
    (*DTW_ptr).label_wid = 0
    (*DTW_ptr).text_wid = 0
    (*DTW_ptr).title_wid = 0
    ;
    WIDGET_CONTROL, Event.top, /DESTROY
    ;
end
;
; Empty stub procedure used for autoloading.
;
pro Dialog_Text_Window_eventcb
end
;
;-----------------------------------------------------------------
pro Dialog_Text_Cancel_Asserted, Event
	;
    ;
    w_id = Event.top
    WIDGET_CONTROL, w_id, GET_UVALUE=DTW_ptr
    ;
    ;	set all wids to -1 to signify cancel
    ;
    (*DTW_ptr).label_wid = -1
    (*DTW_ptr).text_wid = -1
    (*DTW_ptr).title_wid = -1
    ;
    WIDGET_CONTROL, Event.top, /DESTROY
    ;
end
