pro MSP_BDP_Observation_Classify, Event, filter_summary_name, observation_summary_name
	;
	;	classify observation as:
	;
	;	Bias, Dark, Image, Spec, Pol-Imag,
	;	Pol-Spec, I-Flat-On, I-Flat-Off,
	;	P-Flat-On, P-Flat-Off,
	;	S-Flat-On, S-Flat-Off, S-Argon, Lin-On, Lin-Off
	;	R-Flat-On, R-Flat-Off		- for measuring readout times
	;	PCal-On, PCal-Off			- for measuring polarization efficiencies
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	f_ptr = PTR_struct.PTR_FITS
	;n_ptr = PTR_struct.PTR_night
	;
	object = STRUPCASE( STRTRIM( (*f_ptr).object,2 ))
	comment1 = STRUPCASE( STRTRIM( (*f_ptr).comment[0],2 ))
	comment2 = STRUPCASE( STRTRIM( (*f_ptr).comment[1],2 ))
	;
	obcc = object+' '+comment1+' '+comment2
	;
	if( STRPOS( obcc, "DARK") ge 0) then dark = 1 else dark = 0
	if( STRPOS( obcc, "BIAS") ge 0) then bias = 1 else bias = 0
	if( STRPOS( obcc, "FLAT") ge 0) then flat = 1 else flat = 0
	if( STRPOS( obcc, "DOME") ge 0) then dome = 1 else dome = 0
	if( STRPOS( obcc, "READOUT") ge 0) then readout = 1 else readout = 0
	if( STRPOS( obcc, "LIGHT")ge 0 or STRPOS( obcc, "LITE") ge 0) then $
					light = 1 else light = 0
	if( STRPOS( obcc, "LAMP") ge 0) then lamp = 1 else lamp = 0
	if( STRPOS( obcc, " ON")  ge 0) then on = 1 else on = 0
	if( STRPOS( obcc, "OFF") ge 0 or STRPOS( obcc, "NO ") ge 0) then off = 1 else off = 0
	if( STRPOS( obcc, "POL")  ge 0 or STRPOS( obcc, "BD1 ") ge 0) then pol = 1 else pol = 0
	if( STRPOS( obcc, "HWP")  ge 0) then pol = 1
	if( STRPOS( obcc, "SPEC") ge 0) then spec = 1 else spec = 0
	if( STRPOS( obcc, "ARGON")ge 0 or STRPOS( obcc, "AGON")ge 0) then argon = 1 else argon = 0
	if( STRPOS( obcc, "LIN")  ge 0) then lin = 1 else lin = 0
	if( STRPOS( obcc, "CONTIN") ge 0) then contin = 1 else contin = 0
	;
	;	polar calibration with HR polaroid
	;
	if( STRPOS( obcc, "HN-") ge 0) then pcal = 1 else pcal = 0
	if( STRPOS( obcc, "HR-") ge 0) then pcal = 1
	;
	;filter_type = (*n_ptr).image_filter[number]
	;
	filter_type = filter_summary_name
	;
	if( STRPOS( filter_type, "Spec") ge 0) then s_filt = 1 else s_filt = 0
	if( STRPOS( filter_type, "Pol")  ge 0) then p_filt = 1 else p_filt = 0
	if( STRPOS( filter_type, "Dark") ge 0) then d_filt = 1 else d_filt = 0
	if( STRPOS( filter_type, "Img")  ge 0) then i_filt = 1 else i_filt = 0
	;
	;	dark first
	;
	osn = ''
	;
	if(d_filt) then begin
		if(dark) then osn = "Dark"
		;
		;	but bias can trump dark
		;
		if(bias) then osn = "Bias"
	endif
	;
	;	flats and related
	;
	if((light or lin or dome or flat or contin or lamp) and NOT(argon)) then begin
		if(on or NOT(off)) then begin
			if(pol and p_filt) then osn = "P-Flat-On"
			if(lin and NOT(d_filt)) then osn = "Lin-On"
			if(s_filt) then osn = "S-Flat-On"
			if(dome or flat and i_filt) then osn = "I-Flat-On"
			if(readout) then osn = "R-Flat-On"
			if(pcal) then osn = "PCal-On"
		endif else begin
			if(off) then begin
				if(pol and p_filt) then osn = "P-Flat-Off"
				if(lin and NOT(d_filt)) then osn = "Lin-Off"
				if(s_filt) then osn = "S-Flat-Off"
				if(dome or flat and i_filt) then osn = "I-Flat-Off"
				if(readout) then osn = "R-Flat-Off"
				if(pcal) then osn = "PCal-Off"
			endif
		endelse
	endif else begin
	;
	;	not flats
	;
		if(pol or p_filt) then begin
			if(spec) then osn = "Pol-Spec" else osn = "Pol-Img"
		endif
		;
		if(s_filt) then osn = "Spec"
		;
		if(argon) then osn = "S-Argon"
		;
		if(NOT(pol) and NOT(s_filt) and i_filt) then osn = "Image"
	endelse
	;
	; if none of the above, dump all the comments into the name buffer
	;
	if(osn ne '') then begin
		observation_summary_name = osn
	endif else begin
		object = STRTRIM( (*f_ptr).object,2 )
		comment1 = STRTRIM( (*f_ptr).comment[0],2 )
		comment2 = STRTRIM( (*f_ptr).comment[1],2 )
		;
		obcc = object+' '+comment1+' '+comment2
		observation_summary_name = obcc
	endelse
	;
end
