pro MSP_BDP_Parse_HWP_Angle, Event, angle
	;
	;	get the HWP angle (in degrees):
	;
	;	[0.675 deg per step]
	;
	;	20100619 DPC added rectification to "normal" angles (in 22.5 deg steps)
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	f_ptr = PTR_struct.PTR_FITS
	n_ptr = PTR_struct.PTR_night
	;
	;	if this is an "old" type FITS header, must parse a comment field
	;
	if( (*f_ptr).header_version eq 0) then begin
		;
		;	search comment list for "BD1"
		;
		max_comment = 25
		for icomm = 0, max_comment-1 do begin
			if(STRLEN( (*f_ptr).comment[icomm]) ne 0) then begin
				bd_test = STRPOS( STRUPCASE( (*f_ptr).comment[icomm] ), 'BD1')
				if(bd_test ne -1) then goto, start_test
			endif
		endfor
	;	MSP_BDP_print_text, Event, "Warning - couldn't find BD1 in FITS comments"
	;	print, "ERROR - couldn't find BD1 in FITS comments"
		angle = -99.0
		goto, the_end
		;
		start_test:
		comment1 = STRUPCASE( STRTRIM( (*f_ptr).comment[icomm],2 ))
		;
		s0 = STRPOS( comment1, "GOTO")
		s1 = STRPOS( comment1, '.')
		s3 = STRPOS( comment1, 'HOME')
		;
		istep = 0L
		if(s0 ge 0) then begin
			if(s1 ge 0) then begin
				if(s3 ge 0) then begin
					angle = 0.0
				endif else begin
					hwp_string = STRMID( comment1, s0+5, (s1-s0-5))
					reads, hwp_string, format='(i)', istep
					angle = float(istep) * 0.675d0
				endelse
			endif else begin
				;
				;	no dots... so, parse with spaces
				;
				len = STRLEN(comment1) - s0
				remainder = STRMID(comment1, s0, len-1)
				parts = STRSPLIT(remainder, ' ',/REGEX,/EXTRACT)
				len1 = STRLEN(parts[1])			; "GOTO" is parts[0]
				if(len1 ne 0) then begin
					nstep = STRTRIM(parts[1],2)
					reads, nstep, format='(i)', istep
					angle = float(istep) * 0.675d0
				endif else angle = -99.0
			endelse
		endif else begin
			if(s3 ge 0) then begin
				angle = 0.0
			endif else begin
				angle = -99.9
			endelse
		endelse
		;
		the_end:
	endif else begin
		;
		;	if a "new" header version, angle resolution has already
		;	been performed
		;
		angle = (*f_ptr).hwp_ang
	endelse
	;
	;	now, rectify into one of the 16 "normal" values
	;
	angle = normal_angle(angle)
end
