pro MSP_BDP_Restore_Night_File, Event, night_file_path, description, ierr
	;
	;	recovers the night summary structure from the indicated save file
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	;
	CATCH, ierr
	if(ierr ne 0) then begin
		MSP_BDP_print_text, Event, "ERROR - Cannot restore night file "+night_file_path+". Does not exist."
		ierr = 1
		goto, MBRNF_end
	endif
	;
	RESTORE, DESCRIPTION=description, FILENAME=night_file_path
	;
	;	look to see if this is a 'new' night-file (20130920)
	;
	test = TAG_NAMES((*n_ptr))
	ind = WHERE(test eq 'IMAGE_COADDS',ntest)
	if(ntest eq 0) then begin
		;
		;	old style night-file, add new tag name via inheritance
		;
		max_image = (*n_ptr).max_image
		;
		;	must load the old fashioned way...
		;
		FITS_struct =  {    image_id:	0L,		$			; image number from observations
						naxis1:		0,		$			; number of columns in image
						naxis2:		0,		$			; number of rows in image
						observer:	'',		$			; name(s) of observers
						CDS:		1,		$			; 1 for CDS, 0 for non-CDS
						LST_obs:	0.0d0,	$			; LST, in decimal hours
						ra_tele:	0.0d0,	$			; RA of the telescope, in radians
						dec_tele:	0.0d0,	$			; Dec of telescope, in radians
						airmass:	0.0,	$			; Airmass
						instrument:	'',		$			; Name of instrument
						filter:		strarr(5),$			; Filter names for up to 5 filter wheels
						raw_filename:	'',	$			; Image Filename as originally obtained
						objname:	'',		$			; Object Name
						object:		'',		$			; Object
						date_obs:	'',		$			; Date, time of observation (string)
						exptime:	0.0,	$			; Exposure time, in seconds
						ut:			0.0d0,	$			; UT at start of exposure, in decimal hours
						numcoadds:	1,		$			; Number of Coadds making up this exposure
						;
						;	new 20100608
						;
						header_version:	0L,	$			; FITS header version: 0 = pre 2010; 1 = 2010 +
						camera_pos:	0L,		$			; Camera position, in steps from home
						slit_pos:	0L,		$			; Slit position, in detents from home
						decker_pos:	0L,		$			; Decker position, in detents from home
						hwp_step:	0L,		$			; HPW position, in steps
						hwp_ang:   0.0,		$			; HWP position angle, in degrees
						hwp_home:	0L,		$			; HWP home flag
						;
						comment:	strarr(25) }		; Comment blockimage_number:		   '',  $		  ; full image number identifier -- TBD
    	;
		max_image = 9000L
	    header_list = REPLICATE(FITS_struct,max_image)
	    ;
	    group_struct = {   group_id:			    0,  $		  ; consective number of this group (0 start)
	                       group_images:            0,  $         ; number of images in this group
	                       group_start:             0,  $         ; first image number of images in this group
	                       group_end:               0,  $         ; last image number of images in this group
	                       group_list:   intarr(1000),  $         ; list of all image numbers in this group
	                       group_object:           '',  $		  ; object name for images in this group
	                       group_type:             '',  $         ; image type for this group
	                       group_filter:           '',  $         ; filter designation for this group
	                       group_exptime:         0.0,  $         ; exposure time (or -1.0 if many, ie linearity run)
	                       group_frame:            '',  $         ; full frame or NCxNR subframe format
	                       group_readout_mode:      0,  $         ; group readout mode
	                       group_camera:           '',  $         ; camera mode for group
	                       group_coadds:			1   $		  ; number of coadds in each image in the group
	                     }
	    ;
	    noel = 0
	    if(noel) then mgr = 500 else mgr = 250
	    ;
	    groups = REPLICATE(group_struct,mgr)
	    ;
		new_struct = {								$
					   night_desig:			   0L,	$		  ; designation of the current night with data in this structure
					   max_image: 		max_image, 	$		  ; memory sized for this maximum number of images
    			       cds_ok:				   	0,  $		  ; flag to indicate that the CDS_RAW directory was found and was not empty
    			       raw1_ok:				    0,  $		  ; same for RAW1_RAW directory
    			       ;cds_pathname:		   '',  $		  ; pathname to CDS_RAW directory
    			       ;raw1_pathname:		   '',	$		  ; pathname to RAW1_RAW directory
                       num_images:	           0L,	$         ; number of images in the current structure
                       ;
                       paths_cds_root:  strarr(10), $		  ; root CDS directories for different processing levels
                       paths_raw1_root: strarr(10), $		  ; same, for RAW1 directories
                       ;									  ; N.B> both are *relative* to (*summary).root_raw, if
                       ;									  ;   the index = 0, and (*summary).root_reduced, if > 0
                       ;									  ;
                       image_root_index: lonarr(max_image), $ ; indices for each image for root CDS, RAW1 selection
                       ;
                       image_list:  intarr(max_image),	$	  ; vector of image numbers
                       ;
                       num_groups:			   0L,  $		  ; number of identified groupings of images
                       max_groups:          mgr-1,  $         ; maximum space for groups
                       groups:             groups,	$		  ; group structure for this night
                       ;
                       ;	keywords for image table
                       ;
                       image_name:		strarr(max_image),	$		; image names
                       image_object:	strarr(max_image),  $		; object name
                       image_type:		strarr(max_image),	$		; image type - "Image", "Bias", "Dark", "Flat-On", "Flat-Off", "Pol", "Spec"
                       image_filter:	strarr(max_image),	$		; simple filter summary (e.g., "H", "H-Pol", "JHK", "LM" etc.)
                       image_exptime:	fltarr(max_image),	$		; exposure time, in seconds
                       image_HWP_angle:	fltarr(max_image),	$		; HWP angle, in degrees
                       image_ski_jump:	intarr(max_image),	$		; two decimal integers: 00 = TB, so 11 = dual ski jump, 01=bottom ski jump only
					   image_frame:		strarr(max_image),  $		; "Full" or "NC x NR" frame format
					   image_camera:	strarr(max_image),	$		; camera type - F5, F17, PV
					   image_readout_mode:	intarr(max_image),$		; 1 = "sweet spot"; 0 = "deep wells"
                       image_comment:	strarr(max_image),	$		; one line of comment, not included above
                       ;
                       header_list: header_list			 ,  $		; vector of structures, each holding one image header
					   ;
					   image_coadds:    intarr(max_image)   $
				}
		;
		nn_ptr = PTR_NEW(new_struct)
		;
		;	copy values from one to the other
		;
		(*nn_ptr).night_desig = (*n_ptr).night_desig
		(*nn_ptr).cds_ok = (*n_ptr).cds_ok
		(*nn_ptr).raw1_ok = (*n_ptr).raw1_ok
		(*nn_ptr).num_images = (*n_ptr).num_images
        (*nn_ptr).paths_cds_root[*] = (*n_ptr).paths_cds_root[*]
        (*nn_ptr).paths_raw1_root[*] = (*n_ptr).paths_raw1_root[*]
        (*nn_ptr).image_root_index[*] = (*n_ptr).image_root_index[*]
        (*nn_ptr).image_list[*] = (*n_ptr).image_list[*]
        (*nn_ptr).num_groups = (*n_ptr).num_groups
        (*nn_ptr).max_groups = (*n_ptr).max_groups
        ;
        for i = 0, mgr-1 do begin
        	(*nn_ptr).groups[i].group_id = (*n_ptr).groups[i].group_id
        	(*nn_ptr).groups[i].group_images = (*n_ptr).groups[i].group_images
        	(*nn_ptr).groups[i].group_start = (*n_ptr).groups[i].group_start
        	(*nn_ptr).groups[i].group_end = (*n_ptr).groups[i].group_end
        	(*nn_ptr).groups[i].group_list[*] = (*n_ptr).groups[i].group_list[*]
        	(*nn_ptr).groups[i].group_object = (*n_ptr).groups[i].group_object
        	(*nn_ptr).groups[i].group_type = (*n_ptr).groups[i].group_type
        	(*nn_ptr).groups[i].group_filter = (*n_ptr).groups[i].group_filter
        	(*nn_ptr).groups[i].group_exptime = (*n_ptr).groups[i].group_exptime
        	(*nn_ptr).groups[i].group_frame = (*n_ptr).groups[i].group_frame
        	(*nn_ptr).groups[i].group_readout_mode = (*n_ptr).groups[i].group_readout_mode
        	(*nn_ptr).groups[i].group_camera = (*n_ptr).groups[i].group_camera
        	(*nn_ptr).groups[i].group_coadds = 1			; new variable
        endfor
        ;
        ;	and load all the image information, with the new coadds keyword
        ;
        (*nn_ptr).image_name[*] = (*n_ptr).image_name[*]
    	(*nn_ptr).image_object[*] = (*n_ptr).image_object[*]
    	(*nn_ptr).image_type[*] = (*n_ptr).image_type[*]
    	(*nn_ptr).image_filter[*] = (*n_ptr).image_filter[*]
    	(*nn_ptr).image_exptime[*] = (*n_ptr).image_exptime[*]
    	(*nn_ptr).image_HWP_angle[*] = (*n_ptr).image_HWP_angle[*]
    	(*nn_ptr).image_ski_jump[*] = (*n_ptr).image_ski_jump[*]
    	(*nn_ptr).image_frame[*] = (*n_ptr).image_frame[*]
    	(*nn_ptr).image_camera[*] = (*n_ptr).image_camera[*]
    	(*nn_ptr).image_readout_mode[*] = (*n_ptr).image_readout_mode[*]
    	(*nn_ptr).image_comment[*] = (*n_ptr).image_comment[*]
    	(*nn_ptr).header_list = (*n_ptr).header_list
    	(*nn_ptr).image_coadds[*] = 1					; default value
		;
		;	load into internal structure
		;
		PTR_struct.PTR_night = nn_ptr
		;
		;	and free old version
		;
		PTR_FREE, n_ptr
		;
		MSP_BDP_print_text, Event, 'Read an old (<20130920) style night file and converted to new style'
		;
		;	write it back out over the old file in new format
		;
		SAVE, nn_ptr, DESCRIPTION="Night Summary File for "+STRING(format='(I8.8)',$
	                  (*nn_ptr).night_desig), FILENAME=night_file_path
	    ;
	    MSP_BDP_print_text, Event, 'Wrote updated night summary file to disk'
	    ;
	endif else begin
		;
		;	is 'new' type, just load into internal structure
		;
		PTR_struct.PTR_night = n_ptr
	endelse
	;
	;	update pointer structure
	;
	WIDGET_CONTROL, Event.top, SET_UVALUE=PTR_struct
	;
	MBRNF_end:
	CATCH, /CANCEL
end
