pro P10_init, Event
	;
	;	gets the list of active nights with Step>=8 (LC must be ready
	;	first) onto the P10 list and does all
	;		other initializations
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE = PTR_struct
	s_ptr = PTR_struct.PTR_summary
	b_ptr = PTR_struct.PTR_BPM
	ff_ptr = PTR_struct.PTR_Flat
	;
	num_nights = (*s_ptr).num_nights
	;
	if(num_nights eq 0) then begin
		str_list = ['no nights on list']
	endif else begin
		night_list = (*s_ptr).night_date[0:num_nights-1]
		step_list = (*s_ptr).night_step[0:num_nights-1]
		ind = WHERE(step_list[*] ge 8, count)
		if(count lt 1) then begin
			str_list = ['no nights w/S>=8']
			MSP_BDP_print_text, Event, "No Nights Available for Flat Field Image Creation"$
								+" - Complete Linearity Correction first."
		endif else begin
			;
			;	put into structure array
			;
			(*ff_ptr).n_nights = count
			for i=0, count-1 do begin
				(*ff_ptr).night_list[i] = night_list[ind[i]]
				;
				;print,"night ",i," desig = ",(*d_ptr).night_list[i]
				;
			endfor
		endelse
	endelse
	;
	;	clear LED and buttons
	;
	for il = 0, 1 do P10_LED_sensitize, Event, il, 0
	;
	for ib = 0, N_ELEMENTS((*s_ptr).P10_button_wid)-1 do begin
		if(ib eq 0 or ib eq 9) then sens = 1 else sens = 0
		P10_button_sensitize, Event, ib, sens
	endfor
	;
	;	clear draw screens
	;
	for iw = 0, 1 do begin
		WSET, (*s_ptr).P10_draw_window_id[iw]
		ERASE
	endfor
	;
	;	set tab to current
	;
	WIDGET_CONTROL, (*s_ptr).P10_tab_wid, SET_TAB_CURRENT=(*s_ptr).P10_current_tab
	;
	;	check for presence of non-empty intermediate directories
	;
	dir_coadd = (*s_ptr).root_reduced + '10_Flat_Field_Images' + PATH_SEP() + 'coadded_images' + PATH_SEP()
	test = FILE_INFO(dir_coadd)
	if(test.exists and test.directory) then begin
		;
		;	test for not empty
		;
		result = FILE_SEARCH(dir_coadd+'*.fits', count=count)
		if(count ne 0) then begin
			MSP_BDP_print_text, Event, "Found coadded directory with"+STRING(format='(I3.1)',count)+ ' images present'
			P10_button_sensitize, Event, 3, 1
		endif
	endif
	;
	;	same test for polarimetry
	;
	dir_coadd = (*s_ptr).root_reduced + '10_Flat_Field_Images' + PATH_SEP() + 'polar_coadded_images' + PATH_SEP()
	test = FILE_INFO(dir_coadd)
	if(test.exists and test.directory) then begin
		;
		;	test for not empty
		;
		result = FILE_SEARCH(dir_coadd+'*.fits', count=count)
		if(count ne 0) then begin
			MSP_BDP_print_text, Event, "Found polar coadded directory with"+STRING(format='(I3.1)',count)+ ' images present'
			P10_button_sensitize, Event, 12, 1
		endif
	endif
	;
	dir_dif = (*s_ptr).root_reduced + '10_Flat_Field_Images' + PATH_SEP() + 'difference_images' + PATH_SEP()
	test = FILE_INFO(dir_dif)
	if(test.exists and test.directory) then begin
		;
		;	test for not empty
		;
		result = FILE_SEARCH(dir_dif+'*.fits', count=count)
		if(count ne 0) then begin
			MSP_BDP_print_text, Event, "Found differenced directory with "+STRING(format='(I3.1)',count)+ ' images present'
			P10_button_sensitize, Event, 6, 1
		endif
	endif
	;
	;	and polar version, again
	;
	dir_dif = (*s_ptr).root_reduced + '10_Flat_Field_Images' + PATH_SEP() + 'polar_difference_images' + PATH_SEP()
	test = FILE_INFO(dir_dif)
	if(test.exists and test.directory) then begin
		;
		;	test for not empty
		;
		result = FILE_SEARCH(dir_dif+'*.fits', count=count)
		if(count ne 0) then begin
			MSP_BDP_print_text, Event, "Found polar differenced directory with "+STRING(format='(I3.1)',count)+ ' images present'
			P10_button_sensitize, Event, 15, 1
		endif
	endif
	;
	;	test for presence of polar flats in the flat directory - if present, light up button for testing for zero hop
	;		DPC - 20091223
	;
	dir_test = (*s_ptr).root_reduced + '10_Flat_Field_Images' + PATH_SEP() + 'Flt_*_HWP_*'
	pol_list = FILE_SEARCH(dir_test)
	;
	;	if none, will get back null scalar string
	;
	n_files = N_ELEMENTS(pol_list)
	if(n_files eq 1) then begin
		len = STRLEN(pol_list)
		;
		;	if len zero, then no files, jump out
		goto, no_files
	endif
	;
	;	pol files exist - light up test light
	;
	MSP_BDP_print_text, Event, "Found Polar Flat-Fields Exist - enabling Zero Hop Testing"
	P10_button_sensitize, Event, 18, 1
	;
	no_files:
	;
end