pro P5_droplist_populate, Event
	;
	;	puts the list of active nights with Step>=4 (RAW1 Jump tests
	;		must be completed first) onto the P5 droplist
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE = PTR_struct
	s_ptr = PTR_struct.PTR_summary
	b_ptr = PTR_struct.PTR_BPM
	;
	d_wid = (*s_ptr).P5_droplist_night_wid[0]
	;
	num_nights = (*s_ptr).num_nights
	;
	if(num_nights eq 0) then begin
		str_list = ['no nights on list']
	endif else begin
		night_list = (*s_ptr).night_date[0:num_nights-1]
		step_list = (*s_ptr).night_step[0:num_nights-1]
		ind = WHERE(step_list[*] ge 4, count)
		if(count lt 1) then begin
			str_list = ['no nights w/S>=4']
			MSP_BDP_print_text, Event, "No Nights Available for BPM Creation - Complete RAW1 Jump Analysis first."
		endif else begin
			;
			;	convert to strings
			;
			str_list = strarr(count)
			for i=0, count-1 do begin
				str_list[i] = STRING(format='(I8.8)',night_list[ind[i]])
			endfor
		endelse
	endelse
	;
	WIDGET_CONTROL, d_wid, SET_VALUE=str_list
	;
	;	also, set radio buttons to default values
	;
	(*b_ptr).bpm_radio_flags[*] = 0
	(*b_ptr).bpm_radio_flags[0] = 1
	(*b_ptr).bpm_histo_flags[*] = 0
	(*b_ptr).bpm_histo_flags[0] = 1
	for ib = 2,4 do WIDGET_CONTROL, (*s_ptr).P5_button_wid[ib], SET_BUTTON=(*b_ptr).bpm_radio_flags[ib-2]
	for ib = 8,9 do WIDGET_CONTROL, (*s_ptr).P5_button_wid[ib], SET_BUTTON=(*b_ptr).bpm_histo_flags[ib-8]
	;
	;	clear draw screen
	;
	WSET, (*s_ptr).P5_draw_window_id
	ERASE
	;
	;	clear LED
	;
	P5_LED_sensitize, Event, 0, 0
	;
	;	load default low, high cuts into text boxes
	;
	WIDGET_CONTROL, (*s_ptr).P5_text_wid[0], SET_VALUE = STRTRIM(STRING(format='(F7.1)',(*b_ptr).bpm_default_low_cut),2)
	WIDGET_CONTROL, (*s_ptr).P5_text_wid[1], SET_VALUE = STRTRIM(STRING(format='(F7.1)',(*b_ptr).bpm_default_high_cut),2)
end