pro Test_Fix_Bad_Filter_Names, Event, filt_type, $
								PATHNAME=pathname, HEADER=header
	;
	;	opens a FITS file, reads the filter names
	;
	;	if any are "Value Not Set", it rewrites all of them
	;	based on the filter type from the group structure
	;
	;	if pathname set, then open that file and write that file
	;	if header set, then just read from and fix that header
	;	if BOTH are set, read from file into header (no write)
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	filt_ptr = PTR_struct.PTR_filt
	n_ptr = PTR_struct.PTR_night
	;
	if(N_ELEMENTS(PATHNAME) eq 0) then rw_flag = 0 else rw_flag = 1
	if(N_ELEMENTS(HEADER) eq 0) then use_head = 0 else use_head = 1
	;
	;	verify that obs_type matches known type
	;
	ind = WHERE(filt_type eq (*filt_ptr).types[*].Name, count)
	if(count ne 1) then begin
		MSP_BDP_print_text, Event, "Error in Test_Fix_Bad_Filter_Names - count = "+STRING(format='(i)',count)
		goto, the_end
	endif
	;
	;	ok, ind points to correct image type
	;
	ind = ind[0]
	;
	if(rw_flag) then image = readfits(pathname, header, /silent)
	;
	;	test for bad filter names in header, fix if bad
	;
	test_filt = 1
	for i_filt = 0, 3 do begin
		filt_text = FXPAR(header, 'FILTNME'+STRING(format='(I1)',i_filt+1))
		if(STRPOS(STRUPCASE(filt_text),"VALUE NOT SET") ne -1) then begin
			test_filt = 0
		endif
	endfor
	;
	;	if any were bad, rewrite all
	;
	if(test_filt eq 0) then begin
		;
		for i_filt = 0, 3 do begin
			this_filter_name = (*filt_ptr).types[ind].FW[i_filt,0]
			FXADDPAR, header, 'FILTNME'+STRING(format='(I1)',i_filt+1), $
					this_filter_name, "repaired with MSP_BDP: TFBFN"
			;
			;	NB: Can't fix wheel position index, as that lookup table isn't saved
			;
			;print, "fixing filter ",i_filt+1,' name - now = ',(*filt_ptr).types[ind].FW[i_filt,0]
			;
		endfor
		;
		;	rewrite image
		;
		if(rw_flag and NOT(use_head)) then writefits, pathname, image, header, /silent
		;
	endif
	;
	the_end:
end