function truncate, array
;
;   computes rms and then truncates to +/- 10 rms
;
;   DPC 20050726
;     20050728 reduced loop count to 1 to speed processing. Probably
;             don't need more loops with median_filtered_mean present
;
sz = size(array)
out_array = array
ncol = sz[1]
nrow = sz[2]
;
;   do 3 loops to get rid of really extreme values
;   grabbing the rms computation
;
;   reset to one pass 20050728 to speed processing
;
nloop = 0
for iloop = 0, nloop do begin
    rms = 0.0d0
    for irow = 0, nrow-1 do begin
       vec = out_array[*,irow]
       zz = median_filtered_mean(vec)
       rms = rms + zz[1] * zz[1]
    endfor
    rms = sqrt(rms/float(nrow))
    test = 10.0 * rms
    for irow = 0, nrow-1 do begin
       ind_hi = where(out_array[*,irow] gt test,hi_count)
       if(hi_count gt 0) then out_array[ind_hi,irow] = test
       ind_lo = where(out_array[*,irow] lt -test,lo_count)
       if(lo_count gt 0) then out_array[ind_lo,irow] = -test
    endfor
endfor
;
return, out_array
end